/* Sistemas Integrados TEKNISA

Nome: 5013_FISFUNO_CTBL_PRODUTO.SQL

@C:\Web_411\Sql\End_Conv\Oracle\5013_FISFUNO_CTBL_PRODUTO.SQL

Descrio:
Funo para retornar a conta contabil dos produtos da nota fiscal.

P_CDPRODUTO       - Cdigo do produto da nota fiscal.
P_IDENTRSAID      - identificador de entrada\saida da nota fiscal.

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
11/04/2008 - Fabrcio Marcelo da Silva
*/

CREATE OR REPLACE FUNCTION CTBL_PRODUTO
   (P_CDPRODUTO  IN PRODUTO.CDPRODUTO%TYPE,
    P_IDENTRSAID IN NOTAFISCAL.IDENTRSAIDOP%TYPE) RETURN VARCHAR
AS
   V_CDCTBLENTRPR   VARCHAR2(20);
   V_CDCTBLSAIDPR   VARCHAR2(20);
   V_CDARVPROD      VARCHAR2(20);
BEGIN
   V_CDCTBLENTRPR  := NULL;
   V_CDCTBLSAIDPR  := NULL;
   V_CDARVPROD     := NULL;

   BEGIN
      SELECT CDARVPROD
        INTO V_CDARVPROD
        FROM PRODUTO
       WHERE CDPRODUTO = P_CDPRODUTO;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDARVPROD := NULL;
   END; 

   BEGIN
      SELECT PR.CDCTBLENTRPR AS CDCTBLENTRPR, PR.CDCTBLSAIDPR AS CDCTBLSAIDPR
        INTO V_CDCTBLENTRPR, V_CDCTBLSAIDPR
        FROM PRODUTO PR,
            (SELECT MAX(CDARVPROD) CDARVPROD
               FROM (SELECT CDARVPROD AS CDARVPROD 
                       FROM PRODUTO C 
                      WHERE V_CDARVPROD LIKE C.CDARVPROD ||'%'
                        AND CDCTBLENTRPR IS NOT NULL
                        AND 'E' = P_IDENTRSAID)
              UNION
             SELECT MAX(CDARVPROD) CDARVPROD
               FROM (SELECT CDARVPROD AS CDARVPROD
                       FROM PRODUTO C
                      WHERE V_CDARVPROD LIKE C.CDARVPROD ||'%'
                        AND CDCTBLSAIDPR IS NOT NULL
                        AND 'S' = P_IDENTRSAID)) P 
        WHERE PR.CDARVPROD = P.CDARVPROD;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDCTBLENTRPR := NULL;
         V_CDCTBLSAIDPR := NULL;
   END;

   IF P_IDENTRSAID = 'E' THEN
      RETURN(V_CDCTBLENTRPR);
   ELSE
      RETURN(V_CDCTBLSAIDPR);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CTBL_PRODUTO','5.05.025'); END;
/

