/*+
|                                                                 |
|                      Procedure: ETLRESUFOOD                     |
|                                                                 |
|  Rotina para insero de dados de BI - Planejamento/ Tecfood    |
|                                                                 |
|  Tabelas: 1-ETL_RESUFOOD - Produtos  2- ETL_RESUSERV - Servios |
|                                                                 |
|  Criao:                                                       |
|    14/08/2007 - Danilo dos Anjos Faria                          |
|                                                                 |
|  Alteraes:                                                    |
|    20/05/2008 - Danilo dos Anjos Faria                          |
|        Acrscimo dos campos "Data de                           |
|         Processamento" e "Tipo de Servio"                      |
|                                                                 |
|    02/06/2008 - Leandro Corra Gonalves                        |
|        Acrscimo do campo "Preo de Venda dos servios"        |
|                                                                 |
|                                                                 |
|    08/08/2008 - Leandro Corra Gonalves                        |
|        Acrscimo dos Calculos dos fatos Calculados             | 
|                                                                 |
|          							  |
|     08/07/2009 - Leandro Corra Gonalves                       |
|         Acrscimo dos calculos dos fatos                       |
|          Custo Padrao Estimado (VRCUSTPADREST)                  |                          
|          Custo Padrao Efetivo (VRCUSTPADREFE)                   |
|          e alterao do select do cursor                        |  
|          C_PRODUTO por uma divergencia                          |
|          com o relatrio CUS01100                               |
|          (Custo Planejado X Realizado)                          |
|                                                                 |
|                                                                 | 
|                                                                 |
+*/

IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'ETLRESUFOOD')
   DROP PROCEDURE ETLRESUFOOD
GO

CREATE PROCEDURE ETLRESUFOOD
      (  @P_DTINI       DATETIME, 
         @P_DTFINA      DATETIME
      ) 
AS
   DECLARE @V_COUNTER         NUMERIC ; 
   DECLARE @V_DTFIM           DATETIME; 
   DECLARE @V_DTINI           DATETIME; 

   DECLARE @V_DTFINAL         DATETIME;

   DECLARE @V_DATAINICIO      VARCHAR(20); --> Receber a varivel @V_DTINI no formato string
   DECLARE @V_DATAFINAL       VARCHAR(20); --> Receber a varivel @V_DTFIN no formato string
                             
   DECLARE @V_NRTIPOCUSTO1    NUMERIC; 
   DECLARE @V_NRTIPOCUSTO2    NUMERIC;    
   DECLARE @V_NRTIPOCUSTO3    NUMERIC;

   DECLARE @V_NMTIPOCUSTO1    VARCHAR(50);
   DECLARE @V_NMTIPOCUSTO2    VARCHAR(50);
   DECLARE @V_NMTIPOCUSTO3    VARCHAR(50);
                              
   DECLARE @V_VRCUSTPADR      DOUBLE PRECISION ;   
   DECLARE @V_ZERO            DOUBLE PRECISION ;   
   DECLARE @V_CDSEQUENCIAL    CHAR(20); 
   DECLARE @V_NOVO_CODIGO     VARCHAR(100);
                                        
   DECLARE @V_MES             VARCHAR(02); 
   DECLARE @V_ANO             VARCHAR(04);    
   DECLARE @V_BIM             VARCHAR(06); 
   DECLARE @V_TRI             VARCHAR(06); 
   DECLARE @V_SEM             VARCHAR(06);
                                          
-----DECLARE VARIAVEIS C_NRTPCUSTO-----
   DECLARE @V_LINHA           VARCHAR(04);
   DECLARE @V_NRTIPOCUSTO     VARCHAR(04);
                                          
-----DECLARE VARIAVEIS C_ETL-----
   DECLARE @V_CDFILIAL        VARCHAR(04);  
   DECLARE @V_CDAREAGERE      VARCHAR(04);
   DECLARE @V_DTINICIALBI     VARCHAR(25);
   DECLARE @V_CDSUPERVISOR    VARCHAR(12);
   DECLARE @V_CDGOPERAC       VARCHAR(12);
   DECLARE @V_CDEMPRESA       VARCHAR(04);
   DECLARE @V_CDSEGMER        VARCHAR(10);
   DECLARE @IDCOMCUSPERC      CHAR(1);
   DECLARE @V_DTPROCESSA      DATETIME;
                                            
-----DECLARE VARIAVEIS C_SERVICO-----
   DECLARE @V_CDSERVFILI       VARCHAR(10);     
   DECLARE @V_CDGRUPSERV       VARCHAR(10);
   DECLARE @V_QTCOMESTICAR     DOUBLE PRECISION;
   DECLARE @V_QTCOMEFETCAR     DOUBLE PRECISION;
   DECLARE @V_QTCOMESTICAR_PLA DOUBLE PRECISION;
   DECLARE @V_VRPRECVENDA      DOUBLE PRECISION;
   DECLARE @V_DTCARDAPIO_PLA   DATETIME;
   DECLARE @TIPOSERVSERV       VARCHAR(50);

   DECLARE @V_CDCLIENTE        VARCHAR(21);
                          
-----DECLARE VARIAVEIS C_PRODUTO-----
   DECLARE @V_CDFILIAL_P      VARCHAR(04);
   DECLARE @V_CDSERVFILI_P    VARCHAR(10);
   DECLARE @V_CDGRUPSERV_P    VARCHAR(10);
   DECLARE @V_CUSTOPLAN1      DOUBLE PRECISION;
   DECLARE @V_CUSTOPLAN2      DOUBLE PRECISION;
   DECLARE @V_CUSTOPLAN3      DOUBLE PRECISION;
   DECLARE @V_CUSTOREAL1      DOUBLE PRECISION;
   DECLARE @V_CUSTOREAL2      DOUBLE PRECISION;
   DECLARE @V_CUSTOREAL3      DOUBLE PRECISION;
   DECLARE @V_CDPRODUTO_P     VARCHAR(15);
   DECLARE @TIPOSERVFOOD      VARCHAR(50);

----DECLARE VARIAVEIS FATOS CALCULADOS--------

   DECLARE @V_VRCUSTPLANTOTAL1   DOUBLE PRECISION,
           @V_VRCUSTPLANTOTAL2   DOUBLE PRECISION,
           @V_VRCUSTPLANTOTAL3   DOUBLE PRECISION,

           @V_VRCUSTREALTOTAL1   DOUBLE PRECISION,
           @V_VRCUSTREALTOTAL2   DOUBLE PRECISION,
           @V_VRCUSTREALTOTAL3   DOUBLE PRECISION,

           @V_VRTOTALCUSTOSTD    DOUBLE PRECISION,

           @V_VRTOTFCPLAN1       DOUBLE PRECISION,
           @V_VRTOTFCPLAN2       DOUBLE PRECISION,
           @V_VRTOTFCPLAN3       DOUBLE PRECISION,

           @V_VRTOTFCREAL1       DOUBLE PRECISION,
           @V_VRTOTFCREAL2       DOUBLE PRECISION,
           @V_VRTOTFCREAL3       DOUBLE PRECISION,

           @V_VRTOTVENDSERV      DOUBLE PRECISION,
           @V_VRTOTCUSTPADREST   DOUBLE PRECISION,
           @V_VRTOTCUSTPADREFE   DOUBLE PRECISION,
           @V_VRTOTCUSTSTDSERV   DOUBLE PRECISION;                                                     
                                                     
BEGIN
-----INICIALIZANDO VARIAVEIS-----   
   SET @V_COUNTER         = 0;         
   SET @V_CDSEQUENCIAL    = NULL;                             
   SET @V_NRTIPOCUSTO1    = 0;
   SET @V_NRTIPOCUSTO2    = 0;
   SET @V_NRTIPOCUSTO3    = 0;

   SET @V_NMTIPOCUSTO1    = ' ';
   SET @V_NMTIPOCUSTO2    = ' ';
   SET @V_NMTIPOCUSTO3    = ' ';
                              
   SET @V_CDCLIENTE       = NULL;
   SET @V_VRCUSTPADR      = 0;
   SET @V_ZERO            = 0;
   SET @V_LINHA           = 0;
 
   SET @V_MES  =  (CONVERT (VARCHAR, MONTH (@P_DTINI))); 
   SET @V_ANO  =  (CONVERT (VARCHAR, YEAR  (@P_DTINI)));    
 
   BEGIN TRANSACTION
      DELETE FROM ETL_RESUSERV --> tabela de servio
      WHERE (ANETLSERV > @V_ANO)  
        OR  (ANETLSERV = @V_ANO AND MEETLSERV >= @V_MES);  
   COMMIT TRANSACTION;

   BEGIN TRANSACTION 
      DELETE FROM ETL_RESUFOOD  --> tabela de produto
      WHERE (ANETLFOOD > @V_ANO)  
         OR (ANETLFOOD = @V_ANO AND MEETLFOOD >= @V_MES);  
   COMMIT TRANSACTION;    
                                      
   SET @V_DTINI = CONVERT(DATETIME,('01/'+@V_MES+'/'+@V_ANO),103);
   DECLARE C_NRTPCUSTO CURSOR FOR --> Seleciona 3 tipos de custo parametrizados (no CVI)
      (
       SELECT TOP 3 CONVERT(INT, CDTIPOCUSTO, 103) AS NRTIPOCUSTO
       FROM TIPOCUSTO
       WHERE IDTPCUSTOGSC = 'S'
      )                                        
   OPEN C_NRTPCUSTO;
                                     
   SET @V_LINHA = 1;
                                     
   FETCH NEXT FROM C_NRTPCUSTO INTO @V_NRTIPOCUSTO;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF @V_LINHA = 1 BEGIN
            SET @V_NRTIPOCUSTO1 = @V_NRTIPOCUSTO;
            SET @V_LINHA = 2;
         END 
         ELSE IF @V_LINHA = 2 BEGIN                              
            SET @V_NRTIPOCUSTO2 = @V_NRTIPOCUSTO;
            SET @V_LINHA = 3;
         END 
         ELSE IF @V_LINHA = 3 BEGIN                      
            SET @V_NRTIPOCUSTO3 = @V_NRTIPOCUSTO;
         END;
         FETCH NEXT FROM C_NRTPCUSTO INTO @V_NRTIPOCUSTO;
      END;
   CLOSE C_NRTPCUSTO;
   DEALLOCATE C_NRTPCUSTO;

    -->INICIO WHILE LOOP VERIFICA DATA INICIAL / DATA FINAL<-- 
   WHILE (@V_DTINI  <=  @P_DTFINA) BEGIN     
      BEGIN TRANSACTION -->INICIO BEGIN PARA COMMIT<--

         SET @V_DTFIM =  DATEADD(MM, 1,@V_DTINI);                                          
         SET @V_DTFIM =  DATEADD(DD,-1,@V_DTFIM);

         SET   @V_MES   =  CONVERT (VARCHAR, MONTH(@V_DTFIM));
         SET   @V_ANO   =  CONVERT (VARCHAR, YEAR(@V_DTFIM) );
         SET   @V_BIM   =  CONVERT (VARCHAR, (ROUND(((@V_MES - 1) / 2),0) + 1))+' Bim';
         SET   @V_TRI   =  CONVERT (VARCHAR, (ROUND(((@V_MES - 1) / 3),0) + 1))+' Tri';
         SET   @V_SEM   =  CONVERT (VARCHAR, (ROUND(((@V_MES - 1) / 6),0) + 1))+' Sem'; 
                                         
         DECLARE C_ETL CURSOR FOR
           (
            SELECT 
                   FL.CDFILIAL,        FL.CDAREAGERE,          FL.DTINICIALBI,
                   FL.CDSUPERVISOR,    FL.CDGOPERAC,           FL.CDEMPRESA,
                   FL.CDSEGMER,        P.DTPROCESSA,           P.IDCOMCUSPERC
            FROM  
                 FILIAL FL,PARAMFILIAL P
            WHERE P.CDFILIAL = FL.CDFILIAL
              AND FL.IDFUNCAOFILI IS NULL     
              AND FL.DTINICIALBI  IS NOT NULL
              AND P.DTPROCESSA    >= @V_DTINI
           ) 
         OPEN C_ETL;
         FETCH NEXT FROM C_ETL INTO
                                    @V_CDFILIAL,      @V_CDAREAGERE,  @V_DTINICIALBI,
                                    @V_CDSUPERVISOR,  @V_CDGOPERAC,   @V_CDEMPRESA,
                                    @V_CDSEGMER,      @V_DTPROCESSA,  @IDCOMCUSPERC;
         WHILE (@@FETCH_STATUS = 0) BEGIN   

            IF (@V_DTPROCESSA - 1 <= @V_DTFIM) BEGIN --> CONSIDERA UM DIA ANTES DA DATA DE PROCESSAMENTO
               SET @V_DTFINAL = @V_DTPROCESSA - 1;
            END
            ELSE 
               SET @V_DTFINAL = @V_DTFIM;
                         
            IF (CONVERT (DATETIME, ('01' + '/' + CONVERT(VARCHAR, MONTH(@V_DTINICIALBI))+'/'+ CONVERT (VARCHAR, YEAR(@V_DTINICIALBI)))) <= @V_DTINI) BEGIN
               SET @V_NOVO_CODIGO  =  'CONSPLAN' + @V_CDFILIAL;
                                         
               EXEC NOVO_CODIGO @V_NOVO_CODIGO, @P_SEQUENCIAL = @V_CDSEQUENCIAL OUTPUT; 
               SET @V_CDSEQUENCIAL = SUBSTRING(@V_CDSEQUENCIAL,11,10); 
                                             
              /*PREENCHE OS DADOS NECESSRIOS PARA CUSTO PLANEJADO - TABELA CONSPLAN*/  
                                      
               SET @V_DATAINICIO  =  ('_' + CONVERT(VARCHAR(8), CONVERT(DATETIME, @V_DTINI), 112) + '_'); -- formato de data: 'yyyymmdd'
               SET @V_DATAFINAL   =  ('_' + CONVERT(VARCHAR(8), CONVERT(DATETIME, @V_DTFIM), 112) + '_');

               EXEC CONSUMO_PLANEJADO_PLA
                                  @V_CDFILIAL,
                                  'T',
                                  @V_DTINI,
                                  @V_DTFIM,
                                  'T',
                                  'CFP',
                                  'N',
                                   0,
                                  'N',
                                  @V_CDSEQUENCIAL,
                                  '0',
                                  'zzzzzzzzzz',
                                  '', --> Nenhum operador ser necessrio aqui
                                  @V_DATAINICIO,
                                  @V_DATAFINAL;

            /*DADOS EM NVEL DE SERVIO*/
            DECLARE C_SERVICO CURSOR FOR  
             (  
                SELECT
                      SE.CDSERVFILI,  SE.CDGRUPSERV,
                      SUM((CASE @IDCOMCUSPERC WHEN 'C' THEN SE.QTCLIESTICAR ELSE SE.QTCOMESTICAR END) / TOTAL ) AS QTCOMESTICAR,
                      SUM((CASE @IDCOMCUSPERC WHEN 'C' THEN SE.QTCLIEFETCAR ELSE SE.QTCOMEFETCAR END) / TOTAL) AS QTCOMEFETCAR,
                      SE.IDSERVPRINC
                 FROM
                      (
                       SELECT
                            DTCARDAPIO, 
                            SRV.CDSERVFILI, GS.CDGRUPSERV, 
                            (CASE SRV.IDSERVPRINC WHEN 'S' THEN 'Servio Principal' ELSE 'Outros Servios'END) AS IDSERVPRINC,
                            SUM(ISNULL(CAR.QTCOMESTICAR,0)) QTCOMESTICAR,
                            SUM(ISNULL(CAR.QTCOMEFETCAR,0)) QTCOMEFETCAR,
                            SUM(ISNULL(CAR.QTCLIESTICAR,0)) QTCLIESTICAR,
                            SUM(ISNULL(CAR.QTCLIEFETCAR,0)) QTCLIEFETCAR,
                            COUNT(*) AS TOTAL

                       FROM                                 
                             SERVICO SRV,   CARDADIA CAR,
                             GRUPSERV GS

                       WHERE (CAR.CDFILIAL       =   SRV.CDFILIAL)
                         AND (CAR.CDSERVFILI     =   SRV.CDSERVFILI)
                         AND (SRV.CDFILIAL       =   @V_CDFILIAL)
                         AND (CAR.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFINAL)
                         AND (SRV.CDGRUPSERV    *=   GS.CDGRUPSERV) 

                      GROUP BY
                            DTCARDAPIO,
                            SRV.CDSERVFILI,
                            SRV.CDFILIAL,
                            SRV.IDSERVPRINC,
                            GS.CDGRUPSERV
                       ) SE
                 GROUP BY SE.CDSERVFILI, SE.CDGRUPSERV, SE.IDSERVPRINC
   
               )   
            OPEN C_SERVICO;                                            
            FETCH NEXT FROM C_SERVICO INTO  
                                           @V_CDSERVFILI,     @V_CDGRUPSERV,
                                           @V_QTCOMESTICAR,   
                                           @V_QTCOMEFETCAR,   @TIPOSERVSERV;
            WHILE(@@FETCH_STATUS = 0) BEGIN  
                                                                                             
                     SELECT                                              
                           @V_VRCUSTPADR = ISNULL(CUS.VRCUSTPADR, 0)  --> Valor do custo padro               
                     FROM    
                           CUSTPADR CUS
                     WHERE    
                           CUS.CDFILIAL     = @V_CDFILIAL
                      AND  CUS.CDSERVFILI   = @V_CDSERVFILI
                      AND  CUS.DTREFCUSPADR = (SELECT MAX(DTREFCUSPADR)
                                               FROM   CUSTPADR CPD
                                               WHERE  CPD.CDFILIAL      = @V_CDFILIAL
                                                 AND  CPD.CDSERVFILI    = @V_CDSERVFILI
                                                 AND  CPD.DTREFCUSPADR <= @V_DTFINAL);
                     IF (@V_VRCUSTPADR IS NULL) BEGIN
                        SET @V_VRCUSTPADR = 0;
                     END;
                           
                     SET @V_CDCLIENTE   = NULL;                                          
                     SELECT V_CDCLIENTE = CF.CDCLIENTE
                     FROM   CLIENFILIAL CF, CLIENTE B
                     WHERE  CF.CDFILIAL = @V_CDFILIAL
                        AND CF.CDCLIENTE = B.CDCLIENTE
                        AND CF.IDCLIENPRIN = 'S';

                     /*Preo de Venda vindo do histrico*/
                     SET @V_VRPRECVENDA = 0;
                     IF (@V_CDCLIENTE IS NOT NULL) BEGIN
                         SELECT V_VRPRECVENDA = ISNULL(MAX(VRSERVFATHIS), 0)
                         FROM HISTSERVFATU
                         WHERE CDFILIAL     = @V_CDFILIAL
                           AND CDSERVFILI   = @V_CDSERVFILI
                           AND CDCLIENTE    = @V_CDCLIENTE
                           AND DTSRVFATUHIS = (SELECT MAX(DTSRVFATUHIS)
                                               FROM  HISTSERVFATU
                                               WHERE CDFILIAL     = @V_CDFILIAL
                                                 AND CDCLIENTE    = @V_CDCLIENTE
                                                 AND CDSERVFILI   = @V_CDSERVFILI
                                                 AND DTSRVFATUHIS <= @V_DTFINAL);

                     END;

                  DECLARE C_PRODUTO CURSOR FOR    /*DADOS EM NVEL DE PRODUTO*/
                  (
                   SELECT
                      PR.CDFILIAL,
                      PR.CDSERVFILI,
                      GPS.CDGRUPSERV,
                      SUM(PR.CUSTOPLAN1) AS CUSTOPLAN1,
                      SUM(PR.CUSTOPLAN2) AS CUSTOPLAN2,
                      SUM(PR.CUSTOPLAN3) AS CUSTOPLAN3,
                      SUM(PR.CUSTOREAL1) AS CUSTOREAL1,
                      SUM(PR.CUSTOREAL2) AS CUSTOREAL2,
                      SUM(PR.CUSTOREAL3) AS CUSTOREAL3,
                      PR.CDPRODUTO,
                      SE.IDSERVPRINC
                   FROM
                      FILIAL FI, SERVICO SE, GRUPSERV GPS,
                      (SELECT CDFILIAL, CDSERVFILI, DTCARDAPIO
                         FROM CARDADIA
                         WHERE CDFILIAL = @V_CDFILIAL
                           AND(CDSERVFILI = @V_CDSERVFILI)
                           AND(DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFINAL)
                       GROUP BY
                         CDFILIAL,
                         CDSERVFILI,
                         DTCARDAPIO) CD,
                      (SELECT
                         PROD.CDFILIAL,
                         PROD.CDSERVFILI,
                         PROD.DTCARDAPIO,
                         SUM(PROD.CUSTOPLAN1) CUSTOPLAN1,
                         SUM(PROD.CUSTOPLAN2) CUSTOPLAN2,
                         SUM(PROD.CUSTOPLAN3) CUSTOPLAN3,
                         SUM(PROD.CUSTOREAL1) CUSTOREAL1,
                         SUM(PROD.CUSTOREAL2) CUSTOREAL2,
                         SUM(PROD.CUSTOREAL3) CUSTOREAL3,
                         PROD.CDPRODUTO
                      FROM
                        (SELECT
                            CP.CDFILICPLA CDFILIAL,
                            CP.CDSERVCPLA CDSERVFILI,
                            CP.DTCONSPLAN DTCARDAPIO,
                            (TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO1,
                                           (CASE PG.IDUTCARDPADR WHEN 'S'THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END),
                                           GETDATE()) * CP.QTCONSPLAN) AS CUSTOPLAN1,
                            (TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO2,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END),
                                           GETDATE()) * CP.QTCONSPLAN) AS CUSTOPLAN2,
                            (TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO3,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END),
                                           GETDATE()) * CP.QTCONSPLAN) AS CUSTOPLAN3,
                            0 AS CUSTOREAL1,
                            0 AS CUSTOREAL2,
                            0 AS CUSTOREAL3,
                            CP.CDPRODCPLA CDPRODUTO
                         FROM
                            CONSPLAN CP, PARAMGERAL PG,
                            (SELECT CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD, MAX(CM.DTREFECUSTMES) AS DTREFECUSTMES
                               FROM CARDADIA CD, CARDAMES CM
                              WHERE (CD.CDFILIAL = @V_CDFILIAL)
                                AND (CD.CDSERVFILI = @V_CDSERVFILI)
                                AND (CD.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFINAL)
                                AND (CD.CDFILIAL   *= CM.CDFILIAL )
                                AND (CD.CDSERVFILI *= CM.CDSERVFILI )
                                AND (CD.DTMESCARD  *= CM.DTMESCARDAPIO )
                              GROUP BY CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD) CD
                         WHERE (CP.CDFILICPLA   = @V_CDFILIAL)
                           AND(CP.NRCONSPLAN   = @V_CDSEQUENCIAL)
                           AND(CD.CDFILIAL     = CP.CDFILICPLA)
                           AND(CD.CDSERVFILI   = CP.CDSERVCPLA)
                           AND(PG.CDPARGERAL   = '0001')
                           AND(CD.DTMESCARD    = CONVERT(DATETIME,('01/'+@V_MES+'/'+@V_ANO),103))
                         UNION ALL
                         SELECT
                            CD.CDFILIAL,
                            CD.CDSERVFILI,
                            CD.DTCARDAPIO,
                            (CASE @V_NRTIPOCUSTO1 WHEN NULL THEN 0 ELSE ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) *(CD.QTCOMESTICAR/H.TOTCOMEN), 5)END) AS CUSTOPLAN1,
                            (CASE @V_NRTIPOCUSTO2 WHEN NULL THEN 0 ELSE ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) *(CD.QTCOMESTICAR/H.TOTCOMEN), 5)END) AS CUSTOPLAN2,
                            (CASE @V_NRTIPOCUSTO3 WHEN NULL THEN 0 ELSE ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) *(CD.QTCOMESTICAR/H.TOTCOMEN), 5)END) AS CUSTOPLAN3,
                            0 AS CUSTOREAL1,
                            0 AS CUSTOREAL2,
                            0 AS CUSTOREAL3,
                            CNE.CDPRODUTO AS CDPRODUTO
                         FROM
                            (SELECT DTMESCARD, CDSERVFILI, SUM(QTCOMESTICAR) AS TOTCOMEN
                               FROM CARDADIA
                              WHERE(CDFILIAL = @V_CDFILIAL)
                                AND(CDSERVFILI = @V_CDSERVFILI)
                                AND(DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFINAL)
                             GROUP BY
                                DTMESCARD,
                                CDSERVFILI
                            ) H,
                            CARDADIA  CD,
                            RATENESTO RNE,
                            CUSTNESTO CNE,
                            DATA      DT
                         WHERE (DT.DTDATA BETWEEN @V_DTINI AND @V_DTFINAL)
                           AND(SUBSTRING(CONVERT(VARCHAR(20),ISNULL(DT.DTDATA,0),112),0,7) = SUBSTRING(CONVERT(VARCHAR(20),ISNULL(CNE.DTCUSTNESTO,0),112),0,7))
                           AND(CNE.CDFILIAL     = @V_CDFILIAL)
                           AND(RNE.CDSERVFILI   = @V_CDSERVFILI)
                           AND(CNE.CDPRODUTO    = RNE.CDPRODUTO)
                           AND(CD.CDFILIAL      = RNE.CDFILIAL)
                           AND(CD.CDSERVFILI    = RNE.CDSERVFILI)
                           AND(CD.DTCARDAPIO    = DT.DTDATA)
                           AND(H.DTMESCARD      = CD.DTMESCARD)
                           AND(H.CDSERVFILI     = RNE.CDSERVFILI)
                           AND(H.TOTCOMEN IS NOT NULL AND H.TOTCOMEN <> 0)
                         UNION ALL
                         SELECT
                            C.CDFILIAL,
                            C.CDSERVFILI,
                            C.DTCARDAPIO,
                            0 CUSTOPLAN1,
                            0 CUSTOPLAN2,
                            0 CUSTOPLAN3,
                            (CASE @V_NRTIPOCUSTO1 WHEN NULL THEN 0 ELSE (C.QTRETIRADA * TEKNISA.CUSTO_PRODUTO(C.CDFILIAL, C.CDPRODUTO,@V_NRTIPOCUSTO1, C.DTCARDAPIO, GETDATE()))END) AS CUSTOREAL1,
                            (CASE @V_NRTIPOCUSTO2 WHEN NULL THEN 0 ELSE (C.QTRETIRADA * TEKNISA.CUSTO_PRODUTO(C.CDFILIAL, C.CDPRODUTO,@V_NRTIPOCUSTO2, C.DTCARDAPIO, GETDATE()))END) AS CUSTOREAL2,
                            (CASE @V_NRTIPOCUSTO3 WHEN NULL THEN 0 ELSE (C.QTRETIRADA * TEKNISA.CUSTO_PRODUTO(C.CDFILIAL, C.CDPRODUTO,@V_NRTIPOCUSTO3, C.DTCARDAPIO, GETDATE()))END) AS CUSTOREAL3,
                            C.CDPRODUTO
                         FROM
                            (SELECT CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDAPIO, SUM(IR.QTRETIRADA * PRA.VRFATOCONV) AS QTRETIRADA,
                                    PRB.CDPRODUTO
                               FROM CARDADIA CA, PRODUTO  PRA, PRODUTO  PRB, ITEMRETI IR
                            WHERE(PRB.CDPRODUTO = PRA.CDPRODESTO)
                              AND(PRA.CDPRODUTO = IR.CDPRODUTO)
                              AND(CA.CDFILIAL   = IR.CDFILIAL)
                              AND(CA.CDFILIAL   = @V_CDFILIAL )
                              AND(CA.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFINAL)
                              AND(CA.CDSERVFILI = @V_CDSERVFILI)
                              AND(CA.NRCARDAPIO = IR.NRCARDAPIO)
                            GROUP BY
                               CA.CDFILIAL,
                               CA.CDSERVFILI,
                               CA.DTCARDAPIO,
                               PRB.CDPRODUTO
                            ) C

                         UNION ALL
                         SELECT
                            RNE.CDFILIAL,
                            RNE.CDSERVFILI,
                            DT.DTDATA      AS DTCARDAPIO,
                            0 AS CUSTOPLAN1,
                            0 AS CUSTOPLAN2,
                            0 AS CUSTOPLAN3,
                            (CASE @V_NRTIPOCUSTO1 WHEN NULL THEN 0 ELSE ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) *(CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END) AS CUSTOREAL1,
                            (CASE @V_NRTIPOCUSTO2 WHEN NULL THEN 0 ELSE ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) *(CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END) AS CUSTOREAL2,
                            (CASE @V_NRTIPOCUSTO3 WHEN NULL THEN 0 ELSE ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) *(CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END) AS CUSTOREAL3,
                            CNE.CDPRODUTO AS CDPRODUTO
                         FROM
                            (SELECT DTMESCARD, CDSERVFILI, SUM(QTCOMEFETCAR) AS TOTCOMEN
                               FROM CARDADIA
                              WHERE(CDFILIAL = @V_CDFILIAL)
                                AND(CDSERVFILI = @V_CDSERVFILI)
                                AND(DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFINAL)
                             GROUP BY
                                DTMESCARD,
                                CDSERVFILI
                             ) TC,
                            CARDADIA  CA,
                            RATENESTO RNE,
                            CUSTNESTO CNE,
                            DATA      DT
                         WHERE(DT.DTDATA BETWEEN @V_DTINI AND @V_DTFINAL)
                           AND(CNE.CDFILIAL    = @V_CDFILIAL)
                           AND SUBSTRING(CONVERT(VARCHAR(20),ISNULL(DT.DTDATA,0),112),0,7) = SUBSTRING(CONVERT(VARCHAR(20),ISNULL(CNE.DTCUSTNESTO,0),112),0,7)
                           AND(CNE.VRREALNESTO IS NOT NULL)
                           AND(RNE.CDFILIAL    = @V_CDFILIAL)
                           AND(RNE.CDSERVFILI = @V_CDSERVFILI)
                           AND(RNE.CDPRODUTO   = CNE.CDPRODUTO)
                           AND(CA.CDFILIAL     = @V_CDFILIAL)
                           AND(CA.CDSERVFILI   = RNE.CDSERVFILI)
                           AND(CA.DTCARDAPIO   = DT.DTDATA)
                           AND(TC.DTMESCARD    = CA.DTMESCARD)
                           AND(TC.CDSERVFILI   = CA.CDSERVFILI)
                           AND(TC.TOTCOMEN IS NOT NULL AND TC.TOTCOMEN <> 0)
                         UNION ALL
                         SELECT
                            RNE.CDFILIAL,
                            RNE.CDSERVFILI,
                            DT.DTDATA       AS DTCARDAPIO,
                            0 AS CUSTOPLAN1,
                            0 AS CUSTOPLAN2,
                            0 AS CUSTOPLAN3,
                            (CASE @V_NRTIPOCUSTO1 WHEN NULL THEN 0 ELSE ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) *(CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END) AS CUSTOREAL1,
                            (CASE @V_NRTIPOCUSTO2 WHEN NULL THEN 0 ELSE ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) *(CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END) AS CUSTOREAL2,
                            (CASE @V_NRTIPOCUSTO3 WHEN NULL THEN 0 ELSE ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) *(CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END) AS CUSTOREAL3,
                            TCN.CDPRODUTO CDPRODUTO
                         FROM
                            DATA        DT,
                            RATENESTO   RNE,
                            CARDADIA    CA,
                            (SELECT DTMESCARD, CDSERVFILI, SUM(QTCOMEFETCAR) AS TOTCOMEN
                               FROM CARDADIA
                              WHERE(CDFILIAL = @V_CDFILIAL)
                                AND(CDSERVFILI = @V_CDSERVFILI)
                                AND(DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFINAL)
                              GROUP BY DTMESCARD, CDSERVFILI
                             ) TC,
                             (SELECT SUBSTRING(CONVERT(VARCHAR(20),ISNULL(NF.DTENTRSAID,0),112),0,7) AS DTMESNF, IP.CDPRODUTO,
                                     SUM(IP.VRTOTAITEM) AS VRTOTAITEM
                                FROM NOTAFISCAL  NF, ITEMPRODUTO IP
                              WHERE (IP.CDFILIAL     = NF.CDFILIAL)
                                AND(IP.NRLANCTONF   = NF.NRLANCTONF)
                                AND(NF.CDFILIRECE   = @V_CDFILIAL)
                                AND(NF.IDENTRSAIDOP = 'E')
                                AND(NF.DTENTRSAID BETWEEN @V_DTINI AND @V_DTFINAL)
                              GROUP BY SUBSTRING(CONVERT(VARCHAR(20),ISNULL(NF.DTENTRSAID,0), 112),0,7), IP.CDPRODUTO
                            ) TCN
                         WHERE (DT.DTDATA BETWEEN @V_DTINI AND @V_DTFINAL)
                           AND(SUBSTRING(CONVERT(VARCHAR(20),ISNULL(DT.DTDATA,0),112),0,7) = TCN.DTMESNF)
                           AND(RNE.CDFILIAL    = @V_CDFILIAL)
                           AND(RNE.CDSERVFILI  = @V_CDSERVFILI)
                           AND(CA.CDFILIAL     = @V_CDFILIAL)
                           AND(CA.CDSERVFILI   = RNE.CDSERVFILI)
                           AND(CA.DTCARDAPIO   = DT.DTDATA)
                           AND(CA.DTCARDAPIO   = DT.DTDATA)
                           AND(TCN.CDPRODUTO   = RNE.CDPRODUTO)
                           AND(TC.DTMESCARD    = CA.DTMESCARD)
                           AND(TC.CDSERVFILI   = CA.CDSERVFILI)
                           AND(TC.TOTCOMEN IS NOT NULL AND TC.TOTCOMEN <> 0)
                           AND(NOT EXISTS (SELECT CDFILIAL
                                             FROM CUSTNESTO
                                            WHERE CDFILIAL    = @V_CDFILIAL
                                              AND DTCUSTNESTO = DT.DTDATA
                                              AND CDPRODUTO   = RNE.CDPRODUTO
                                              AND VRREALNESTO IS NOT NULL))
                        ) PROD
                       GROUP BY CDFILIAL, CDSERVFILI, DTCARDAPIO, CDPRODUTO
                       ) PR
                   WHERE FI.CDFILIAL   = PR.CDFILIAL
                     AND SE.CDFILIAL   = PR.CDFILIAL
                     AND SE.CDSERVFILI = PR.CDSERVFILI
                     AND CD.CDFILIAL   = PR.CDFILIAL
                     AND CD.CDSERVFILI = PR.CDSERVFILI
                     AND CD.DTCARDAPIO = PR.DTCARDAPIO
                     AND SE.CDGRUPSERV *= GPS.CDGRUPSERV
                   GROUP BY
                      PR.CDFILIAL,
                      PR.CDSERVFILI,
                      PR.CDPRODUTO,
                      GPS.CDGRUPSERV,
                      SE.IDSERVPRINC

                   )
                   OPEN C_PRODUTO;
                   FETCH NEXT FROM C_PRODUTO INTO
                                                   @V_CDFILIAL_P,     @V_CDSERVFILI_P,   @V_CDGRUPSERV_P,
                                                   @V_CUSTOPLAN1,     @V_CUSTOPLAN2,     @V_CUSTOPLAN3,
                                                   @V_CUSTOREAL1,     @V_CUSTOREAL2,     @V_CUSTOREAL3,
                                                   @V_CDPRODUTO_P,    @TIPOSERVFOOD;
                   WHILE(@@FETCH_STATUS = 0) BEGIN




                  --------------------------FATOS CALCULADOS----------------------------

                        
                              IF @V_QTCOMESTICAR > 0 BEGIN 
                                 
                                 /* CUSTO PLANEJADO TOTAL */
                                 SET @V_VRCUSTPLANTOTAL1 = (@V_CUSTOPLAN1 / @V_QTCOMESTICAR); 
                                 SET @V_VRCUSTPLANTOTAL2 = (@V_CUSTOPLAN2 / @V_QTCOMESTICAR); 
                                 SET @V_VRCUSTPLANTOTAL3 = (@V_CUSTOPLAN3 / @V_QTCOMESTICAR);
                                 
                                 IF @V_VRPRECVENDA > 0 BEGIN 
                                   
                                   /* PERCENTUAL FC PLAN */
                                   SET @V_VRTOTFCPLAN1 = (@V_CUSTOPLAN1 / (@V_VRPRECVENDA * @V_QTCOMESTICAR)); 
                                   SET @V_VRTOTFCPLAN2 = (@V_CUSTOPLAN2 / (@V_VRPRECVENDA * @V_QTCOMESTICAR)); 
                                   SET @V_VRTOTFCPLAN3 = (@V_CUSTOPLAN3 / (@V_VRPRECVENDA * @V_QTCOMESTICAR)); 

                                 END
                                 ELSE BEGIN
                                   SET @V_VRTOTFCPLAN1  = 0; 
                                   SET @V_VRTOTFCPLAN2  = 0;
                                   SET @V_VRTOTFCPLAN3  = 0;
                                 END ;
                              END
                              ELSE  BEGIN
                                 SET @V_VRCUSTPLANTOTAL1 = 0;
                                 SET @V_VRCUSTPLANTOTAL2 = 0;
                                 SET @V_VRCUSTPLANTOTAL3 = 0;
                                 SET @V_VRTOTFCPLAN1     = 0;
                                 SET @V_VRTOTFCPLAN2     = 0;
                                 SET @V_VRTOTFCPLAN1     = 0;
                              END;
                        
                              
                            IF (@V_QTCOMEFETCAR > 0)  BEGIN
                               
                               /* CUSTO REALIZADO TOTAL */ 
                               SET @V_VRCUSTREALTOTAL1 = (@V_CUSTOREAL1 / @V_QTCOMEFETCAR); 
                               SET @V_VRCUSTREALTOTAL2 = (@V_CUSTOREAL2 / @V_QTCOMEFETCAR); 
                               SET @V_VRCUSTREALTOTAL3 = (@V_CUSTOREAL3 / @V_QTCOMEFETCAR); 
                                  
                               IF @V_VRPRECVENDA > 0 BEGIN
                                 /* PERCENTUAL FC STD */ 
                                 SET @V_VRTOTALCUSTOSTD = ((@V_VRCUSTPADR * @V_QTCOMEFETCAR) /    
                                                            (@V_VRPRECVENDA * @V_QTCOMEFETCAR ));
                                                        
                                                        
                                 /* PERCENTUAL FC REAL */
                                 SET @V_VRTOTFCREAL1 = (@V_CUSTOREAL1 / (@V_VRPRECVENDA * @V_QTCOMEFETCAR)); 
                                 SET @V_VRTOTFCREAL2 = (@V_CUSTOREAL2 / (@V_VRPRECVENDA * @V_QTCOMEFETCAR)); 
                                 SET @V_VRTOTFCREAL3 = (@V_CUSTOREAL3 / (@V_VRPRECVENDA * @V_QTCOMEFETCAR));
                               END
                               ELSE BEGIN
                                  SET @V_VRTOTALCUSTOSTD = 0;   
                                  SET @V_VRTOTFCREAL1    = 0;                    
                                  SET @V_VRTOTFCREAL2    = 0;
                                  SET @V_VRTOTFCREAL3    = 0;
                               END;
                            END
                            ELSE BEGIN
                             SET @V_VRCUSTREALTOTAL1 = 0;
                             SET @V_VRCUSTREALTOTAL2 = 0;
                             SET @V_VRCUSTREALTOTAL3 = 0;
                             SET @V_VRTOTALCUSTOSTD  = 0;
                             SET @V_VRTOTFCREAL1     = 0;
                             SET @V_VRTOTFCREAL2     = 0;
                             SET @V_VRTOTFCREAL3     = 0;
                           END;
                               
                        /* TOTAL DE VENDA POR SERVIO */
                           SET @V_VRTOTVENDSERV = (@V_VRPRECVENDA * @V_QTCOMEFETCAR); 
                             
                        /* TOTAL DE CUSTO STD POR SERVIO */
                           SET @V_VRTOTCUSTSTDSERV = (@V_VRCUSTPADR * @V_QTCOMEFETCAR); 
                                                     
                     --<-------INSERO DE DADOS DE PRODUTO------->--
                                 
                   INSERT INTO ETL_RESUFOOD 
                        ( 
                        CDFILIAL,              CDAREAGERE,             CDSUPERVISOR,
                        CDGOPERAC,             CDEMPRESA,              CDSEGMER,
                        CDPRODUTO,             ANETLFOOD,              MEETLFOOD,
                        BIETLFOOD,             TRETLFOOD,              SEETLFOOD,
                        VRCUSPLAETLFOO1,       VRCUSPLAETLFOO2,        VRCUSPLAETLFOO3,
                        VRCUSREAETLFOO1,       VRCUSREAETLFOO2,        VRCUSREAETLFOO3,
                        CDGRUPSERV,            CDFILISERVFILI,         DSDTPROCETLFOOD,
                        DSTPSERVETLFOOD,       VRCUSPLATOTFOO1,        VRCUSPLATOTFOO2,
                        VRCUSPLATOTFOO3,       VRCUSREATOTFOO1,        VRCUSREATOTFOO2,
                        VRCUSREATOTFOO3,       VRPERTOTFCPLAN1,        VRPERTOTFCPLAN2,
                        VRPERTOTFCPLAN3,       VRPERTOTFCREAL1,        VRPERTOTFCREAL2,
                        VRPERTOTFCREAL3
                        )
                    VALUES 
                        ( 
                        @V_CDFILIAL,           @V_CDAREAGERE,       @V_CDSUPERVISOR,
                        @V_CDGOPERAC,          @V_CDEMPRESA,        @V_CDSEGMER,
                        @V_CDPRODUTO_P,        @V_ANO,              @V_MES,  
                        @V_BIM,                @V_TRI,              @V_SEM,                        
                        @V_CUSTOPLAN1,         @V_CUSTOPLAN2,       @V_CUSTOPLAN3,
                        @V_CUSTOREAL1,         @V_CUSTOREAL2,       @V_CUSTOREAL3,
                        @V_CDGRUPSERV_P,       @V_CDFILIAL + @V_CDSERVFILI_P,
                        CONVERT(CHAR(10), @V_DTPROCESSA,103),       @TIPOSERVFOOD,
                        @V_VRCUSTPLANTOTAL1, @V_VRCUSTPLANTOTAL2, @V_VRCUSTPLANTOTAL3,@V_VRCUSTREALTOTAL1, @V_VRCUSTREALTOTAL2,
                        @V_VRCUSTREALTOTAL3, @V_VRTOTFCPLAN1,@V_VRTOTFCPLAN2,@V_VRTOTFCPLAN3,@V_VRTOTFCREAL1, @V_VRTOTFCREAL2,
                        @V_VRTOTFCREAL3    
                        );   
                                                    			    
                       SET @V_COUNTER = @V_COUNTER + 1; 
                       IF @V_COUNTER >= 500 BEGIN 
                           COMMIT TRANSACTION; 
                           SET @V_COUNTER = 0; 
                           BEGIN TRANSACTION; 
                        END;                   
                      FETCH NEXT FROM C_PRODUTO INTO 
               	         	                  @V_CDFILIAL_P,     @V_CDSERVFILI_P,   @V_CDGRUPSERV_P,
                                                  @V_CUSTOPLAN1,     @V_CUSTOPLAN2,     @V_CUSTOPLAN3,
                                                  @V_CUSTOREAL1,     @V_CUSTOREAL2,     @V_CUSTOREAL3,
                                                  @V_CDPRODUTO_P,    @TIPOSERVFOOD;
                        
                   END; --Fim do loop por produto
                   CLOSE C_PRODUTO;
                   DEALLOCATE C_PRODUTO;
                                                 
                 --<-------INSERO DE DADOS DE SERVIO------->--
                   INSERT INTO ETL_RESUSERV 
                     ( 
                     CDFILIAL,                  CDAREAGERE,
                     CDSUPERVISOR,              CDGOPERAC,
                     CDEMPRESA,                 CDSEGMER,
                     CDGRUPSERV,                CDFILISERVFILI,
                     ANETLSERV,                 MEETLSERV,
                     BIETLSERV,                 TRETLSERV,
                     SEETLSERV,                 QTCOMESTETLSERV,
                     QTCOMEFEETLSERV,           VRCUSPADETLSERV,
                     DSDTPROCETLSERV,           DSTPSERVETLSERV,
                     VRCUSVNDETLSERV,           VRPERTOTCUSTSTD,
                     VRTOTAVENDASERV,           VRTOTCUSSTDSERV,
                     VRCUSPADESTETL,             VRCUSPADEFEETL
                     
                     ) 
                   VALUES 
                     ( 
                     @V_CDFILIAL,            @V_CDAREAGERE,
                     @V_CDSUPERVISOR,        @V_CDGOPERAC,  
                     @V_CDEMPRESA,           @V_CDSEGMER,
                     @V_CDGRUPSERV,          @V_CDFILIAL + @V_CDSERVFILI,
                     @V_ANO,                 @V_MES,    
                     @V_BIM,                 @V_TRI,   
                     @V_SEM,                 @V_QTCOMESTICAR, 
                     @V_QTCOMEFETCAR,        @V_VRCUSTPADR,
                     CONVERT(CHAR(10), @V_DTPROCESSA, 103), @TIPOSERVSERV, 
                     @V_VRPRECVENDA, @V_VRTOTALCUSTOSTD,@V_VRTOTVENDSERV,
                     @V_VRTOTCUSTSTDSERV, @V_VRTOTCUSTPADREST, @V_VRTOTCUSTPADREFE
                     );
                                                                                             
               SET @V_COUNTER = @V_COUNTER + 1; 
               IF @V_COUNTER >= 500 BEGIN 
                  COMMIT TRANSACTION; 
                  SET @V_COUNTER = 0; 
                  BEGIN TRANSACTION; 
               END;
               FETCH NEXT FROM C_SERVICO INTO 
               	         	          @V_CDSERVFILI,     @V_CDGRUPSERV,
                                          @V_QTCOMESTICAR,   
                                          @V_QTCOMEFETCAR,   @TIPOSERVSERV;


               SET @V_VRCUSTPLANTOTAL1   = 0;
               SET @V_VRCUSTPLANTOTAL2   = 0;
               SET @V_VRCUSTPLANTOTAL3   = 0;

               SET @V_VRCUSTREALTOTAL1   = 0;
               SET @V_VRCUSTREALTOTAL2   = 0;
               SET @V_VRCUSTREALTOTAL3   = 0;
   
               SET @V_VRTOTALCUSTOSTD    = 0;
 
               SET @V_VRTOTFCPLAN1       = 0;
               SET @V_VRTOTFCPLAN2       = 0;
               SET @V_VRTOTFCPLAN3       = 0;
   
               SET @V_VRTOTFCREAL1       = 0;
               SET @V_VRTOTFCREAL2       = 0;
               SET @V_VRTOTFCREAL3       = 0;

               SET @V_VRTOTVENDSERV      = 0;
               SET @V_VRTOTCUSTSTDSERV   = 0;

                                    
            END ;   -- fim do loop por servico
            
            CLOSE C_SERVICO;                                                
            DEALLOCATE C_SERVICO;                                            
                                                                                                      
            DELETE FROM CONSPLAN
            WHERE NRCONSPLAN = @V_CDSEQUENCIAL;
                               
         END ;        -- Final da comparao com data de BI                
         FETCH NEXT FROM C_ETL INTO
                                    @V_CDFILIAL,      @V_CDAREAGERE,  @V_DTINICIALBI,
                                    @V_CDSUPERVISOR,  @V_CDGOPERAC,   @V_CDEMPRESA,
                                    @V_CDSEGMER,      @V_DTPROCESSA,  @IDCOMCUSPERC;

      END ;         -- fim do loop por Filial
      CLOSE C_ETL;                                                
      DEALLOCATE C_ETL;                                            
      COMMIT TRANSACTION;
      SET @V_DTINI = DATEADD(MM, 1, @V_DTINI); 
   END ;            -- loop por ms


   --------------------------ATUALIZANDO O NOME DOS FATOS----------------------------

   BEGIN TRANSACTION
      --Updata o nome dos fatos de acordo com o tipo de custo parametrizado...

      IF (@V_NMTIPOCUSTO1 <> ' ') BEGIN
         UPDATE ITEMDW
            SET NMITEMDW = 'Planejado (' + @V_NMTIPOCUSTO1 + ')'
          WHERE CDITEMDW = 'VRCUSPLAETLFOO1';

         UPDATE ITEMDW
            SET NMITEMDW = 'Realizado (' + @V_NMTIPOCUSTO1 + ')'
          WHERE CDITEMDW = 'VRCUSREAETLFOO1';

      END;

      IF (@V_NMTIPOCUSTO2 <> ' ') BEGIN
         UPDATE ITEMDW
            SET NMITEMDW = 'Planejado (' + @V_NMTIPOCUSTO2 + ')'
          WHERE CDITEMDW = 'VRCUSPLAETLFOO2';

         UPDATE ITEMDW
            SET NMITEMDW = 'Realizado (' + @V_NMTIPOCUSTO2 + ')'
          WHERE CDITEMDW = 'VRCUSREAETLFOO2';

      END;

      IF (@V_NMTIPOCUSTO3 <> ' ') BEGIN
         UPDATE ITEMDW
            SET NMITEMDW = 'Planejado (' + @V_NMTIPOCUSTO3 + ')'
          WHERE CDITEMDW = 'VRCUSPLAETLFOO3';

         UPDATE ITEMDW
            SET NMITEMDW = 'Realizado (' + @V_NMTIPOCUSTO3 + ')'
          WHERE CDITEMDW = 'VRCUSREAETLFOO3';
      END;

   COMMIT TRANSACTION;
        
END; 
GO


   BEGIN TRAN;
   -- Cria as dimenses para a tabela ETL_RESUFOOD  no cria para data de processamento 
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'CDSUPERVISOR'    , 'Supervisor'          , 'SUPERVISOR'  , 'CDSUPERVISOR'  , 'NMSUPERVISOR', NULL;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'CDGOPERAC'       , 'Gerente Operacional' , 'GOPERAC'     , 'CDGOPERAC'     , 'NMGOPERAC'   , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'CDEMPRESA'       , 'Empresa'             , 'EMPRESA'     , 'CDEMPRESA'     , 'NMEMPRESA'   , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'CDFILIAL'        , 'Filial'              , 'FILIAL'      , 'CDFILIAL'      , 'NMFILIAL'    , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'CDSEGMER'        , 'Segmento de Mercado' , 'SEGMERCADO'  , 'CDSEGMER'      , 'DSSEGMER'    , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'CDAREAGERE'      , 'Regional'            , 'AREAGERE'    , 'CDAREAGERE'    , 'NMAREAGERE'  , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'CDGRUPSERV'      , 'Grupo de Servios'   , 'GRUPSERV'    , 'CDGRUPSERV'    , 'NMGRUPSERV'  , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'CDPRODUTO'       , 'Produto'             , 'PRODUTO'     , 'CDPRODUTO'     , 'NMPRODUTO'   , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'CDFILISERVFILI'  , 'Servio'             , 'FILISERVFILI', 'CDFILISERVFILI', 'NMSERVICO'   , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'ANETLFOOD'       , 'Ano'                 , NULL          , NULL            , NULL          , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'MEETLFOOD'       , 'Ms'                 , NULL          , NULL            , NULL          , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'BIETLFOOD'       , 'Bimestre'            , NULL          , NULL            , NULL          , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'TRETLFOOD'       , 'Trimestre'           , NULL          , NULL            , NULL          , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'SEETLFOOD'       , 'Semestre'            , NULL          , NULL            , NULL          , NULL ;
   EXEC CRIA_DIME 'ETL_RESUFOOD', 'DSTPSERVETLFOOD' , 'Tipo de Servio'     , NULL          , NULL            , NULL          , NULL ;
   
   -- Cria as dimenses para a tabela ETL_RESUSERV  no cria para data de processamento 
   EXEC CRIA_DIME 'ETL_RESUSERV', 'CDSUPERVISOR'    , 'Supervisor'          , 'SUPERVISOR'  , 'CDSUPERVISOR'  , 'NMSUPERVISOR', NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'CDGOPERAC'       , 'Gerente Operacional' , 'GOPERAC'     , 'CDGOPERAC'     , 'NMGOPERAC'   , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'CDEMPRESA'       , 'Empresa'             , 'EMPRESA'     , 'CDEMPRESA'     , 'NMEMPRESA'   , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'CDFILIAL'        , 'Filial'              , 'FILIAL'      , 'CDFILIAL'      , 'NMFILIAL'    , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'CDSEGMER'        , 'Segmento de Mercado' , 'SEGMERCADO'  , 'CDSEGMER'      , 'DSSEGMER'    , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'CDAREAGERE'      , 'Regional'            , 'AREAGERE'    , 'CDAREAGERE'    , 'NMAREAGERE'  , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'CDGRUPSERV'      , 'Grupo de Servios'   , 'GRUPSERV'    , 'CDGRUPSERV'    , 'NMGRUPSERV'  , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'CDFILISERVFILI'  , 'Servio'             , 'FILISERVFILI', 'CDFILISERVFILI', 'NMSERVICO'   , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'ANETLSERV'       , 'Ano'                 , NULL          , NULL            , NULL          , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'MEETLSERV'       , 'Ms'                 , NULL          , NULL            , NULL          , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'BIETLSERV'       , 'Bimestre'            , NULL          , NULL            , NULL          , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'TRETLSERV'       , 'Trimestre'           , NULL          , NULL            , NULL          , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'SEETLSERV'       , 'Semestre'            , NULL          , NULL            , NULL          , NULL ;
   EXEC CRIA_DIME 'ETL_RESUSERV', 'DSTPSERVETLSERV' , 'Tipo de Servio'     , NULL          , NULL            , NULL          , NULL ;   
   COMMIT TRAN;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ETLRESUFOOD','5.70.xxx';

GO
