import Vue from "vue";
import Vuex from "vuex";

/** Carregar Modulos */
import Cliente from './Cliente';
import Operador from './Operador/index';
import ScreenService from './ScreenService';

Vue.use(Vuex);

export default new Vuex.Store({
	state: {
        appLoginToken: '',
        appLoginHash: '',
        appShowMenu: true,
        appShowHeader: true
    },
	mutations: {
        setAppLoginToken: (state, token: string) => {
            state.appLoginToken = token;
        },
        setAppLoginHash: (state, hash: string) => {
            state.appLoginHash = hash;
        },
        setAppDisplayOptions: (state, options: any) => {
            state.appShowMenu = options.menu !== '0';
            state.appShowHeader = options.header !== '0';
        }
    },
    actions: {},
    getters: {},
	modules: {
        Cliente,
        Operador,
        ScreenService
    }
});
